﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
#Event: Test{n}
Sub Class_Globals

	Private L As List
	Private StartTime, EndTime, TestTime As Long
	Private Results(,) As Long
	Private Finished As Boolean
	Private Iteration As Int
	Private XUI As XUI
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize As Boolean
	#If Debug
		XUI.MsgboxAsync("Tests should be run in Release Mode","Change compilation mode")
	Return False
	#End If
	DateTime.SetTimeZone(0)
	DateTime.TimeFormat = "HH:mm:ss:SSSS"
	Return True
End Sub

'Run Tests showing all detail
Public Sub RunTests1(CallBack As Object,TestCount As Int, IterationCount As Int)
	RunTests(CallBack,TestCount,IterationCount,True,True)
End Sub
'Run Tests showing No detail
Public Sub RunTests2(CallBack As Object,TestCount As Int, IterationCount As Int)
	RunTests(CallBack,TestCount,IterationCount,False,False)
End Sub

'Runtests with detail options
'Callback - The module where the Test1 - Testn methods can be found
'IterationCount - The number of iterations to perform on wach test.
'RunDetail - Set to False to hide the status for individual test
'ResultDetail - Set to False to hide the results of each iteration
Public Sub RunTests(CallBack As Object,TestCount As Int, IterationCount As Int, RunDetail As Boolean, ResultDetail As Boolean)
	
	TestTime = DateTime.Now
	Dim i,j As Int
	
	L.Initialize
	
	
	
	Dim Results(IterationCount,TestCount) As Long
	For Iteration = 0 To IterationCount - 1
		For i = 0 To TestCount - 1
			Results(Iteration,i) = -1
		Next
	Next
	
	For Iteration = 0 To IterationCount -1
	
		If RunDetail Then Log($"******* Starting Iteration ${Iteration+1}"$)
	
		Do While True
			Finished = True
			Dim R As Int = Rnd(0,TestCount)
			If Results(Iteration,R) > -1 Then Continue
		
			If SubExists(CallBack,"Test" & (R+1)) = False Then
				If RunDetail Or Iteration = 0 Then Log($"############################## Test ${R + 1} Not Found"$)
				Results(Iteration,R) = 0
				
			Else
		
				If RunDetail Then Log("Starting Test " & (R+1))
				StartTime = DateTime.Now
			
				CallSub(CallBack,"Test" & (R+1))
			
				EndTime = DateTime.Now
			
				Results(Iteration,R) = EndTime - StartTime
			
				If RunDetail Then Log($"Test ${R+1} Took ${EndTime - StartTime}"$)
			End If
			
			For i = 0 To TestCount - 1
				If Results(Iteration,i) = -1 Then Finished = False
			Next
				
			If Finished Then Exit
		Loop
	
	Next
	
	Dim TestCum(TestCount) As Long
	For Iteration = 0 To IterationCount - 1
		For j = 0 To TestCount-1
			If ResultDetail Then Log($"Iteration ${Iteration + 1} : Test ${j+1} Took ${Results(Iteration,j)} ms"$)
			If Iteration > 0 Then TestCum(j) = TestCum(j) + Results(Iteration,j)
		Next
	Next
	
	For j = 0 To TestCount -1
		Log($"Test ${j+1} Avg is $Time{TestCum(j) / Max(IterationCount - 1,1)}"$)
	Next
	Log($"Total Test Time : $Time{DateTime.Now - TestTime}"$)
End Sub